use num_bigint::BigInt;
use num_rational::{BigRational, Ratio};

type Matrix = Vec<Vec<BigRational>>;

fn main() {
    let mut a: Matrix = vec![
        vec![
            Ratio::from_float::<f64>(10.0).unwrap(),
            Ratio::from_float::<f64>(7.0).unwrap(),
            Ratio::from_float::<f64>(8.1).unwrap(),
            Ratio::from_float::<f64>(7.2).unwrap(),
            Ratio::from_float::<f64>(32.0).unwrap(),
        ],
        vec![
            Ratio::from_float::<f64>(7.08).unwrap(),
            Ratio::from_float::<f64>(5.04).unwrap(),
            Ratio::from_float::<f64>(6.0).unwrap(),
            Ratio::from_float::<f64>(5.0).unwrap(),
            Ratio::from_float::<f64>(23.0).unwrap(),
        ],
        vec![
            Ratio::from_float::<f64>(8.0).unwrap(),
            Ratio::from_float::<f64>(5.98).unwrap(),
            Ratio::from_float::<f64>(9.89).unwrap(),
            Ratio::from_float::<f64>(9.0).unwrap(),
            Ratio::from_float::<f64>(33.0).unwrap(),
        ],
        vec![
            Ratio::from_float::<f64>(6.99).unwrap(),
            Ratio::from_float::<f64>(4.99).unwrap(),
            Ratio::from_float::<f64>(9.0).unwrap(),
            Ratio::from_float::<f64>(9.98).unwrap(),
            Ratio::from_float::<f64>(31.0).unwrap(),
        ],
    ];

    for i in 0..a.len() {
        for j in i..a.len() {
            let divisor = &a[j][i];
            a[j] = a[j].iter().map(|element| element / divisor).collect();
        }

        for j in i + 1..a.len() {
            a[j] = a[j]
                .iter()
                .zip(&a[i])
                .map(|(element, previous)| element - previous)
                .collect();
        }
    }

    for i in (0..a.len()).rev() {
        for j in (0..i).rev() {
            let multiplicator = &a[j][i];
            a[j] = a[j]
                .iter()
                .zip(&a[i])
                .map(|(element, subtractor)| element - subtractor * multiplicator)
                .collect();
        }
    }

    let b: Vec<Vec<BigInt>> = a
        .iter()
        .map(|row| row.iter().map(|element| element.to_integer()).collect())
        .collect();

    println!("result: {:?}", b);
}
